SET TALK OFF
SET ESCAPE OFF
SET PROCEDURE TO TUTOR.CMD
*************************
* GLOBAL VARIABLES
STORE 'SET SAY VIDEO TO 112' TO SAYNORMAL
STORE 'SET SAY VIDEO TO 7' TO SAYREVERSE
STORE 'SET SAY VIDEO TO 15' TO SAYBRIGHT
STORE 'SET SAY VIDEO TO 143' TO SAYBLINK
STORE 'SET ERASE VIDEO TO 112' TO SAYERASE
STORE 'SET GET VIDEO TO 112' TO GETREVERSE
STORE 'SET GET VIDEO TO 7' TO GETNORMAL
STORE CENTER('^U = PgUp  ^D = PgDn   HOME = Main Menu  Esc = Quit',76) TO HELPLINE
STORE 'ASSIGN BOX(05,05,19,74,42,42,42,42,42,42)' TO BIG_BOX
STORE ' ' TO X.ANS
********
USE MAIL
SET SAFETY OFF
*******
*&GETNORMAL
*&SAYERASE
&SAYREVERSE
ERASE
TEXT






                        Welcome to the dBMAN Tutorial !

       This tutorial is designed to teach you all the commands needed to 
       create  and use your own data base.  If you leave  this tutorial, 
       you  may  at  any time type DO TUTOR, and  re-run  this  program.
         
       dBMAN  is easy to use. In just a few short minutes this  tutorial 
       will show you how to CREATE, USE, APPEND, DISPLAY, LOCATE,  EDIT, 
       DELETE, SORT, and INDEX your new data base.  
ENDTEXT
&BIG_BOX
&SAYNORMAL
@ 24,01 SAY CENTER('Please press any key to continue.',78)
WAIT
DO WHILE T
	IF LASTKEY() = 27
		CLEAR
		RETURN
	ENDIF
	&SAYREVERSE
	ERASE
	ASSIGN VMENU('*','GETTING STARTED*CREATE A MAIL LIST*USING A MAIL LIST*ADDING RECORDS*DISPLAYING RECORDS*LOCATING RECORDS*EDITING RECORDS*SORTING RECORDS*INDEXING RECORDS*QUIT',5,1)
	DO CASE
		CASE VMENU() = 1 | GETTING STARTED
			ERASE
			DO TUTORGS0
		CASE VMENU() = 2 | CREATE
			ERASE
			DO TUTORCR0
		CASE VMENU() = 3 | USE
			ERASE
			DO TUTORUS0
		CASE VMENU() = 4 | ADD
			ERASE
			DO TUTORAD0
		CASE VMENU() = 5 | DISPLAY
			ERASE
			DO TUTORDS0
		CASE VMENU() = 6 | LOCATE
			ERASE
			DO TUTORLO0
		CASE VMENU() = 7 | EDIT
			ERASE
			DO TUTORED0
		CASE VMENU() = 8 | SORT
			ERASE
			DO TUTORSO0
		CASE VMENU() = 9 | INDEXING
			ERASE
			DO TUTORID0
		CASE NRANGE(VMENU(),40,49) | HELP
			ERASE
			DO TUTORHLP
		OTHERWISE
                        CLEAR
			RETURN
	ENDCASE
ENDDO
RETURN
***************
PROCEDURE TUTORHLP
***************
@ 10,00 ESAY ' '
TEXT
                         Welcome to the dBMAN Tutorial.

        To select a menu item, simply use the arrow key to highlight  the 
        command you would like to see, then press the return key.

        Each section will discuss the different dBMAN commands  necessary 
        for you to create and use your own data base.  Some sections will 
        even let you enter your own data!  
ENDTEXT
ASSIGN BOX(09,05,19,74,42,42,42,42,42,42)
& SAYNORMAL
@ 24,02 SAY CENTER('PRESS ANY KEY TO CONTUNUE',76)
WAIT
&SAYREVERSE
RETURN
************
PROCEDURE TUTORGS0
************
* TUTORGS0.PRG
DO WHILE T
DO NORMSCR
TEXT




                                THE dBMAN SCREEN

        The  dBMAN screen is divided into two sections, with the  command 
        window at the top and the data window below.  These two  sections 
        will  allow  you  to  see  dBMAN  prompts  and  messages  without 
        disrupting your data display.

        The  command  field is where you enter  commands  for  execution.  
        dBMAN  places the cursor  at the "CMD:" caption when it is  ready 
        to receive a command.  

ENDTEXT
ASSIGN BOX(08,05,19,74,42,42,42,42,42,42)
&SAYNORMAL
@24,02 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORGS1
	CASE Y.LKEY = 'P'
		*CLOSE ALL
		RETURN TO MAIN
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORGS1
**********
DO WHILE T
@ 05,00 ERASE
DO NORMSCR
TEXT



                                THE dBMAN SCREEN

        The message field is where you will receive messages from  dBMAN.  
        The message is posted after the "MSG:" caption; if the message is 
        reporting   an  error,  a  beep  will  sound.   The  message   is 
        automatically erased when you press any key.

        The  file ID field displays the name and file ID of  the  current 
        data  file.   dBMAN will display FP (Primary) when  it  is  first 
        started.   The  current record field displays the  record  number 
        that was last accessed by dBMAN.

ENDTEXT
ASSIGN BOX(07,05,19,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,02 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
       		DO TUTORGS2
	CASE Y.LKEY = 'P'
                @ 05,00 ERASE
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORGS2
************
DO WHILE T
@ 05,00 ERASE
DO NORMSCR
TEXT




                                THE dBMAN SCREEN

        The  key summary field is a second message field that displays  a 
        reminder of which control keys apply to the current command. 

        F7 will display all the memory variables in use.  F8 will display 
        dBMAN  "switches"  and the data files in use.  F9  will  give  an 
        extended explanation of an error message.  F10 will provide  HELP 
        based on the command in the command line.

ENDTEXT
ASSIGN BOX(08,05,19,74,42,42,42,42,42,42)
&SAYNORMAL
@24,02 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORCR0
	CASE Y.LKEY = 'P'
		*CLOSE ALL
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORCR0
************
* CREATE
DO WHILE T
@ 05,00 ERASE 
DO NORMSCR
TEXT







                             Create Mailing List

       The  first  thing you will need to do is to create a  data  base.  
       The  command  you will use is CREATE  <filename.DBF>.   You  will 
       insert your own file name instead of the <>'s.  (Please refer  to 
       your  DOS  manual if you are not sure of what a  proper  filename 
       should be.)  If you do not specify an extension, dBMAN will use  a 
       ".DBF" extension.

       Here we will use the name MAIL.
ENDTEXT
ASSIGN BOX(11,05,22,74,42,42,42,42,42,42)
DO NORMSCR
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORCR1
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORCR1
************
* CREATE
DO WHILE T
@ 06,00 ERASE 
DO NORMSCR
@ 17,00 SAY CENTER('Create Mailing List',79)
TEXT

       Here  we will define the data base structure.  We'll  tell  dBMAN 
       the  name of each field and the type of data we will store in  it 
       (Character, Number, Date, Logical), how many places to reserve in 
       the  record  for the data, and if it is a number type,  how  many 
       decimal places we will need.
ENDTEXT
ASSIGN BOX (16,05,23,74,42,42,42,42,42,42)
X.STRING = 'CREATE MAIL          '
X.STRROW = 0
X.STRCOL = 4
X.STRTIME = 5
DO PRINTTXT
@ 03,04 SAY 'Enter structure'
@ 03,40 SAY RTJUST('FP MAIL.DBF        Rec BOF     ',40)
&SAYNORMAL
@ 04,00 SAY '^S=save ^Q=quit ^E=era ^I=ins'
&SAYREVERSE
@ 05,06 SAY 'fieldname    type        width   decimal'
@ 06,51 SAY 'Bytes remaining :'
@ 07,51 SAY 'No. of fields :'
******
@ 06,70 SAY '4000'
@ 07,73 SAY '1'
******
*FIRSTNAME
*******
@ 06,03 SAY '1'
&SAYNORMAL
@ 06,06 SAY SPACE(10)
@ ROW(),22 SAY ' '
@ ROW(),32 SAY '    '
@ ROW(),42 SAY '  '
X.STRING = 'FIRST_NAME'
X.STRROW = 6
X.STRCOL = 6
X.STRTIME = 5
DO PRINTTXT
X.STRING = 'C'
X.STRROW = 6
X.STRCOL = 22
X.STRTIME = 5
DO PRINTTXT
X.STRING = '  10'
X.STRROW = 6
X.STRCOL = 32
X.STRTIME = 5
DO PRINTTXT
&SAYREVERSE
******
* LAST NAME
******
@ 06,70 SAY '3990'
@ 07,73 SAY '2'
******
@ 07,03 SAY '2'
&SAYNORMAL
@ 07,06 SAY SPACE(10)
@ ROW(),22 SAY ' '
@ ROW(),32 SAY '    '
@ ROW(),42 SAY '  '
X.STRING = 'LAST_NAME '
X.STRROW = 7
X.STRCOL = 6
X.STRTIME = 5
DO PRINTTXT
X.STRING = 'C'
X.STRROW = 7
X.STRCOL = 22
X.STRTIME = 5
DO PRINTTXT
X.STRING = '  20'
X.STRROW = 7
X.STRCOL = 32
X.STRTIME = 5
DO PRINTTXT
&SAYREVERSE
******
* ADDRESS
******
@ 06,70 SAY '3970'
@ 07,73 SAY '3'
******
@ 08,03 SAY '3'
&SAYNORMAL
@ 08,06 SAY SPACE(10)
@ ROW(),22 SAY ' '
@ ROW(),32 SAY '    '
@ ROW(),42 SAY '  '
X.STRING = 'ADDRESS'
X.STRROW = 8
X.STRCOL = 6
X.STRTIME = 5
DO PRINTTXT
X.STRING = 'C'
X.STRROW = 8
X.STRCOL = 22
X.STRTIME = 5
DO PRINTTXT
X.STRING = '  60'
X.STRROW = 8
X.STRCOL = 32
X.STRTIME = 5
DO PRINTTXT
&SAYREVERSE
******
*CITY
*******
@ 06,70 SAY '3910'
@ 07,73 SAY '4'
******
@ 09,03 SAY '4'
&SAYNORMAL
@ 09,06 SAY SPACE(10)
@ ROW(),22 SAY ' '
@ ROW(),32 SAY '    '
@ ROW(),42 SAY '  '
X.STRING = 'CITY'
X.STRROW = 9
X.STRCOL = 6
X.STRTIME = 5
DO PRINTTXT
X.STRING = 'C'
X.STRROW = 9
X.STRCOL = 22
X.STRTIME = 5
DO PRINTTXT
X.STRING = '  15'
X.STRROW = 9
X.STRCOL = 32
X.STRTIME = 5
DO PRINTTXT
&SAYREVERSE
******
* STATE
******
@ 06,70 SAY '3895'
@ 07,73 SAY '5'
******
@ 10,03 SAY '5'
&SAYNORMAL
@ 10,06 SAY SPACE(10)
@ ROW(),22 SAY ' '
@ ROW(),32 SAY '    '
@ ROW(),42 SAY '  '
X.STRING = 'STATE'
X.STRROW = 10
X.STRCOL = 6
X.STRTIME = 5
DO PRINTTXT
X.STRING = 'C'
X.STRROW = 10
X.STRCOL = 22
X.STRTIME = 5
DO PRINTTXT
X.STRING = '   2'
X.STRROW = 10
X.STRCOL = 32
X.STRTIME = 5
DO PRINTTXT
&SAYREVERSE
******
* ZIP
******
@ 06,70 SAY '3893'
@ 07,73 SAY '6'
******
@ 11,03 SAY '6'
&SAYNORMAL
@ 11,06 SAY SPACE(10)
@ ROW(),22 SAY ' '
@ ROW(),32 SAY '    '
@ ROW(),42 SAY '  '
X.STRING = 'ZIP'
X.STRROW = 11
X.STRCOL = 6
X.STRTIME = 5
DO PRINTTXT
X.STRING = 'C'
X.STRROW = 11
X.STRCOL = 22
X.STRTIME = 5
DO PRINTTXT
X.STRING = '   5'
X.STRROW = 11
X.STRCOL = 32
X.STRTIME = 5
DO PRINTTXT
&SAYREVERSE
******
*PHONE
******
@ 06,70 SAY '3888'
@ 07,73 SAY '7'
******
@ 12,03 SAY '7'
&SAYNORMAL
@ 12,06 SAY SPACE(10)
@ ROW(),22 SAY ' '
@ ROW(),32 SAY '    '
@ ROW(),42 SAY '  '
X.STRING = 'PHONE'
X.STRROW = 12
X.STRCOL = 6
X.STRTIME = 5
DO PRINTTXT
X.STRING = 'C'
X.STRROW = 12
X.STRCOL = 22
X.STRTIME = 5
DO PRINTTXT
X.STRING = '  12'
X.STRROW = 12
X.STRCOL = 32
X.STRTIME = 5
DO PRINTTXT
&SAYREVERSE
*********
* LAST
*********
@ 06,70 SAY '3876'
@ 03,04 SAY 'Done                   '
@ 00,04 ESAY ' '
******

&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORCR2
	CASE Y.LKEY = 'P'
		&SAYREVERSE
		@ 00,00 ESAY 'CMD:'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORCR2
************
* CREATE
DO WHILE T
@ 14,00 ERASE
@ 17,00 SAY CENTER('Create Mailing List',80)
TEXT

       NOTE:   Although the phone and zip fields contain  numbers, we'll 
       use the "C" (Character) type.  This will allow us to have leading 
       zero's and use the "-" character.  
ENDTEXT
ASSIGN BOX(16,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORCR3
	CASE Y.LKEY = 'P'
		@ 00,00 ESAY 'CMD:'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORCR3
************
* CREATE
DO WHILE T
@ 14,00 ERASE
@ 17,00 SAY CENTER('Create Mailing List',80)
TEXT
       You will want to set up your data base structure to allow you  to 
       store any data you might want to find later.  Don't worry though, 
       if you don't get it right the first time you can always come back 
       and  add, delete , insert , and rename the fields.  This  can  be 
       done by using the commands MODIFY STRUCTURE and MODIFY FIELDNAME.
ENDTEXT
ASSIGN BOX(16,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
	 ERASE
		DO TUTORUS0
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORUS0
************
DO WHILE T
DO NORMSCR
@ 05,00 ERASE
@ 08,00 SAY CENTER('Use Mailing List',80)
TEXT
       Once  you  have  created  a  data base,  you  will  want  to  put 
       information into it.  But first you will need to USE a data base.  
       The  command  is quite easy.  Just type:  USE  <filename>,  where 
       filename  is the name of your data base.  We'll use the  MAIL.DBF 
       again.

       When  a file is in use, dBMAN will display the selected  area  ID 
       (FP is the default) and the name of the file.  You can have  only 
       one  file open in each area.  If you have more than one  file  in 
       use  and would like to see the file names, you can press  the  F8 
       key.  Try it!
ENDTEXT
ASSIGN BOX(07,05,20,74,42,42,42,42,42,42)
X.STRING = 'USE MAIL'
X.STRROW = 0
X.STRCOL = 4
X.STRTIME = 5
&SAYREVERSE
DO PRINTTXT
@ 00,04 ESAY ' '
@ 03,04 SAY 'DONE' 
@ 03,49 SAY 'FP  MAIL.DBF'
@ 03,69 SAY 'Rec 1'

&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
IF LASTKEY() = 194
	@ 05,00 ERASE
	@ 05,00 SAY ''
	TEXT
APPROX=OFF  CONFIRM=OFF  CONSOLE=ON  DELETED=OFF  ENCRYPT=OFF  ESCAPE=ON
EXACT=OFF  SAFETY=ON  TALK=ON  UNIQUE=OFF
ERRCODE=0  DATE FORMAT=0  USERSTAT=255  GETNO=0
VER=2.00A   INTXX=14H  OPEN MODE=42H
BREAK=OFF//1  DEFAULT(DBF/NDX/TXT/MEM/PRG/Sys/DXX) (//////)
LINE COUNT=60  MARGIN(Top/Bottom/Left) (3/3/0)
PRINT(OFF/1)  TRAP(OFF/)  LOGFILE()
VIDEO(Say/Get/Erase) (7/112/7)


DBF FILE <fid>,<file>,<currec>,<totalrec>
P,MAIL.DBF,1,1

	ENDTEXT
	WAIT 'PgDn to continue. '
	LOOP
	ENDIF
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORAD0
	CASE Y.LKEY = 'P'
		&SAYREVERSE
		ERASE
		@ 00,00 SAY ''
		TEXT
CMD:


MSG:Done                                              FP MAIL.DBF        Rec BOF
^S=save ^Q=quit ^E=era ^I=ins                       F7=Mem F8=Sta F9=Err F10=Cmd
      fieldname    type        width   decimal
   1  FIRST_NAME      C           10               Bytes remaining :  3876
   2  LAST_NAME       C           20               No. of fields :       7
   3  ADDRESS         C           60
   4  CITY            C           15
   5  STATE           C            2
   6  ZIP             C            5
   7  PHONE           C           12



     **********************************************************************
     *                         Create Mailing List                        *
     * You will want to set up your data base structure to allow you  to  *
     * store any data you might want to find later.  Don't worry though,  *
     * if you don't get it right the first time you can always come back  *
     * and  add, delete , insert , and rename the fields.  This  can  be  *
     * done by using the commands MODIFY STRUCTURE and MODIFY FIELDNAME.  *
     **********************************************************************
		ENDTEXT
		&SAYNORMAL
		@ 04,00 SAY '^S=save ^Q=quit ^E=era ^I=ins                       F7=Mem F8=Sta F9=Err F10=Cmd'
		&SAYREVERSE
		EXIT 
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORAD0
************
DO WHILE T
@ 05,00 ERASE
DO NORMSCR
&SAYREVERSE
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 14,00 SAY CENTER('Adding Records',80)
TEXT

        To  add  records  to your data base, you  will  use  the  command 
        APPEND.  APPEND will add new records to the bottom of your file.

ENDTEXT
ASSIGN BOX(13,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORAD1
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORAD1
************
* TUTORAD1.PRG
* CREATE
DO WHILE T
@ 13,00 ERASE
@ 14,00 SAY CENTER('Adding Records',80)
TEXT

        Here you will enter the information in each field.  ^S will  save 
        the record on the disk and return you to the CMD: line.  ^Q  will 
        abandon  the data on the screen and return you to the CMD:  line.  
        ^N  will save the data and ready the screen for the next  record.  
        ^P will allow you to edit the previous record.  (Note: A ^N  will 
        take  you to the end of the file.)  ^C will copy (carryover)  all 
        the data in the record to a new record at the end of the file.
ENDTEXT
&SAYREVERSE
ASSIGN BOX(13,05,23,74,42,42,42,42,42,42)
X.STRING = 'APPEND'
X.STRROW = 0
X.STRCOL = 4
X.STRTIME = 5
&SAYREVERSE
DO PRINTTXT
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 06,00 SAY 'FIRST_NAME'
@ ROW()+1,00 SAY 'LAST_NAME'
@ ROW()+1,00 SAY 'ADDRESS'
@ ROW()+1,00 SAY 'CITY'
@ ROW()+1,00 SAY 'STATE'
@ ROW()+1,00 SAY 'ZIP'
@ ROW()+1,00 SAY 'PHONE'
&SAYNORMAL
@ 04,00 SAY '^S=save ^Q=quit ^N=next ^P=prv ^C=carryover'
@ 06,11 SAY SPACE(10)
@ ROW()+1,11 SAY SPACE(20)
@ ROW()+1,11 SAY SPACE(60)
@ ROW()+1,11 SAY SPACE(15)
@ ROW()+1,11 SAY '  '
@ ROW()+1,11 SAY '     '
@ ROW()+1,11 SAY SPACE(12)
***********
*FIRSTNAME
*********
X.STRING = 'Mike'
X.STRROW = 6
X.STRCOL = 11
X.STRTIME=5
DO PRINTTXT
***********
*LAST NAME
*********
X.STRING = 'Dausend'
X.STRROW = ROW()+1
X.STRCOL = 11
X.STRTIME=5
DO PRINTTXT
***********
* ADDRESS
*********
X.STRING = '723 Seawood Way'
X.STRROW = ROW()+1
X.STRCOL = 11
X.STRTIME=5
DO PRINTTXT
***********
*city
*********
X.STRING = 'San Jose'
X.STRROW = ROW()+1
X.STRCOL = 11
X.STRTIME=5
DO PRINTTXT
***********
*state
*********
X.STRING = 'CA'
X.STRROW = ROW()+1
X.STRCOL = 11
X.STRTIME=5
DO PRINTTXT
***********
*zip
*********
X.STRING = '95120'
X.STRROW = ROW()+1
X.STRCOL = 11
X.STRTIME=5
DO PRINTTXT
***********
*PHONE
*********
X.STRING = '408-268-6033'
X.STRROW = ROW()+1
X.STRCOL = 11
X.STRTIME=5
DO PRINTTXT
&SAYREVERSE
@ 00,04 ESAY ''
@ 03,04 SAY 'DONE'
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORAD2
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORAD2
************
DO WHILE T
ERASE
DO NORMSCR
&SAYREVERSE
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 14,00 SAY CENTER('Adding Records',80)
TEXT

        If you would like to add some of your own records to the database, 
        please  type a ^A. (Hold the control key down while pressing  the 
        "A" key.) 
ENDTEXT
ASSIGN BOX(13,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
IF LASTKEY() = 1
	ERASE
	SET TALK ON
	APPEND
	SET TALK OFF
	Y.LKEY = ' '
ELSE
	DO LKEY
ENDIF
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORDS0
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORDS0
************
* TUTORDS0.PRG
* CREATE
DO WHILE T
ERASE
DO NORMSCR
&SAYREVERSE
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 11,00 SAY CENTER('Displaying Records',80)
TEXT
        There are several commands you can use to look at your data.  One 
        is  the  LIST command.  If you type LIST, dBMAN  will  print  the 
        current  record  on the screen .  LIST ALL will print the  entire 
        data base on your screen in a continuous scrolling fashion.

        Another  command  is  DISPLAY ALL.  DISPLAY ALL  will  print  one 
        screen  of records at a time.  You can use the  ^right-arrow  and 
        the  ^left-arrow to move right or left (pan) through the  fields.  
        If  you  would like to see the DISPLAY ALL command  work  on  the 
        MAIL  data  base,  please  type  ^D. (Hold the control  key  down 
        and press the "D" key.)
ENDTEXT
ASSIGN BOX(10,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
IF LASTKEY() = 4
	ERASE
	SET TALK ON
	DISPLAY ALL
	SET TALK OFF
	Y.LKEY = ' '
ELSE
	DO LKEY
ENDIF
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORED0
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
DO WHILE T
ERASE
DO NORMSCR
&SAYREVERSE
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 11,00 SAY CENTER('Displaying Records',80)
TEXT
        There are several commands you can use to look at your data.  One 
        is  the  LIST command.  If you type LIST, dBMAN  will  print  the 
        current  record  on the screen .  LIST ALL will print the  entire 
        data base on your screen in a continuous scrolling fashion.

        Another  command  is  DISPLAY ALL.  DISPLAY ALL  will  print  one 
        screen  of records at a time.  You can use the  ^right-arrow  and 
        the  ^left-arrow to move right or left (pan) through the  fields.  
        If  you  would like to see the DISPLAY ALL command  work  on  the 
        MAIL  data  base,  please  type  ^D. (Hold the control  key  down 
        and press the "D" key.)
ENDTEXT
ASSIGN BOX(10,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
IF LASTKEY() = 4
	ERASE
	SET TALK ON
	DISPLAY ALL
	SET TALK OFF
	Y.LKEY = ' '
ELSE
	DO LKEY
ENDIF
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORED0
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORLO0
************
* TUTORLO0.PRG
* CREATE
DO WHILE T
@ 05,00 ERASE
GO TOP
DO NORMSCR
&SAYREVERSE
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 11,00 SAY CENTER('Locating Records',80)
TEXT

        Let's say you want to do something with a record, such as  change 
        it.  (More on the EDIT command later.)  In order to use a record, 
        you will need to make it the current record.  One way to do this, 
        if you know the record number, is to use the command GOTO.   Just 
        type  GOTO  <recordnumber>, and fill in the record  number.   For 
        example GOTO 12.
ENDTEXT
ASSIGN BOX(10,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		& SAYREVERSE
		X.STRING = 'GOTO 1   '
		X.STRROW = 0
		X.STRCOL = 4
		X.STRTIME = 5
		DO PRINTTXT
		@ 00,04 ESAY ''
		@ 03,04 SAY 'DONE'
		@ 03,04 SAY '    '
		X.STRING = 'LIST   '
		X.STRROW = 0
		X.STRCOL = 4
		X.STRTIME = 5
		DO PRINTTXT
		@ 06,00 SAY ''
		LIST
		@ 00,04 ESAY ''
		@ 03,04 SAY 'DONE'
			Y.LC = 0
			DO WHILE Y.LC < 20
				INC Y.LC
			ENDDO
		DO TUTORLO1
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORLO1
************
* TUTORLO1.PRG
* CREATE
DO WHILE T
@ 05,00 ERASE
@ 03,04 SAY '    '
GO TOP
DO NORMSCR
&SAYREVERSE
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 11,00 SAY CENTER('Locating Records',80)
TEXT

        Another  way to go to a record is to LOCATE it.  Here are  a  few 
        examples: LOCATE FOR STATE = "CA" ;  LOCATE FOR LAST_NAME >  "D";  
        LOCATE  FOR STATE = "CA" AND LAST_NAME > "D".  dBMAN will try  to 
        find the first record that matches.  If there is no match,  dBMAN 
        will display the message: Err05 - End Of File...No More  Records.  
        Don't  worry  about  getting an error; there  are  just  no  more 
        records.
ENDTEXT
ASSIGN BOX(10,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		& SAYREVERSE
		X.STRING = 'LOCATE FOR STATE = "CA"'
		X.STRROW = 0
		X.STRCOL = 4
		X.STRTIME = 5
		DO PRINTTXT
		LOCATE FOR STATE = 'CA'
		IF EOF()
			BEEP
			@ 03,04 SAY 'Err05 - End Of File...No More  Records'
			Y.LC = 0
			DO WHILE Y.LC < 20
				INC Y.LC
			ENDDO
		ELSE
			@ 00,04 ESAY ''
			@ 03,04 SAY 'DONE'
			X.STRING = 'LIST   '
			X.STRROW = 0
			X.STRCOL = 4
			X.STRTIME = 5
			DO PRINTTXT
			@ 06,00 SAY ''
			LIST
			@ 00,04 ESAY ''
			@ 03,04 SAY 'DONE'
			Y.LC = 0
			DO WHILE Y.LC < 20
				INC Y.LC
			ENDDO
		ENDIF
		DO TUTORED0
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORED0
************
* TUTORED0.PRG
* CREATE
DO WHILE T
ERASE
DO NORMSCR
&SAYREVERSE
GO TOP
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 12,00 SAY CENTER('Editing Records',80)
TEXT

        Here you will enter the information in each field.  ^S will  save 
        the record on the disk and return you to the CMD: line.  ^Q  will 
        abandon  the data on the screen and return you to the CMD:  line.  
        ^N  will save the data and go to the next record.  ^P  will  save 
        the data and allow you to edit the previous record.  ^D will mark 
        the record for deletion.  ^U will remove the deletion mark.
        To permanent remove a deleted record use the PACK command.

        If you would like to EDIT press ^E.
ENDTEXT
ASSIGN BOX(11,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
IF LASTKEY() = 5
	ERASE
	SET TALK ON
	EDIT
	SET TALK OFF
	Y.LKEY = ' '
ELSE
	DO LKEY
ENDIF
DO CASE
	CASE Y.LKEY = 'N'
		DO TUTORSO0
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORSO0
************
* TUTORSO0.PRG
* CREATE
DO WHILE T
ERASE
GO TOP
DO NORMSCR
&SAYREVERSE
@ 03,52 SAY 'MAILL.DBF'
@ 03,73 SAY '1'
@ 12,00 SAY CENTER('Sorting Records',80)
TEXT

        If  you want to look at your data base in a certain order,  dBMAN 
        provides two ways to organize your file: SORTing and INDEXing.

        SORTing  your  file  creates  a  new  data  file  and  physically 
        rearranges  the records into the specified order.  To  sort  your 
        file,  simply  type  SORT ON  <fieldname>  TO  <filename>.   Some 
        examples:   SORT  ON STATE TO STFILE;  SORT ON  NAME  TO  NAFILE.  
        Then to see the new sorted data, you will type USE <filename>.
        To see a sort press ^S.
ENDTEXT
ASSIGN BOX(11,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
IF LASTKEY() = 19
        &SAYREVERSE
		ERASE
		SET TALK ON
		SORT ON LAST_NAME TO TEMP
		USE TEMP
		LIST ALL FIRST_NAME,LAST_NAME
		TEXT
******************************************************************************
*       Notice  how in the record number in the left hand column is in       *
*       order?   The sort will physically reorder the data.                  *
******************************************************************************


        ENDTEXT
        ? '  '
        &SAYNORMAL
        ?? CENTER('PRESS ANY KEY TO CONTINUE',76)
        &SAYREVERSE
        WAIT
        SET TALK OFF
        USE MAIL
        LOOP
ENDIF
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
		ERASE
		SET TALK ON
		SORT ON LAST_NAME TO TEMP
		USE TEMP
		LIST ALL FIRST_NAME,LAST_NAME
		SET TALK OFF
		USE MAIL
		Y.LC=0
		DO WHILE Y.LC < 60
			INC Y.LC
		ENDDO
		DO TUTORID0
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE TUTORID0
************
* TUTORid0.PRG
* CREATE
DO WHILE T
ERASE
GO TOP
DO NORMSCR
&SAYREVERSE
@ 03,52 SAY 'MAIL.DBF'
@ 03,73 SAY '1'
@ 11,00 SAY CENTER('Indexing Records',80)
TEXT

        If  you want to look at your data base in a certain order,  dBMAN 
        provides two ways to organize your file: INDEXing and SORTing.

        INDEXing  your file creates a new file that will make  your  data 
        file  appear  in  the  desired order.   It  does  not  physically 
        rearrange  the  records in the data base.  To  INDEX  your  file, 
        simply  type  INDEX  ON  <fieldname>  TO  <indexfilename>.   Some 
        examples:   INDEX ON STATE TO STFILE;  INDEX ON NAME  TO  NAFILE.  
        Then to see the new sorted data, you will type USE <mainfilename> 
        INDEX  <indexfilename>.  To see an index type ^I.
ENDTEXT
ASSIGN BOX(10,05,23,74,42,42,42,42,42,42)
&SAYNORMAL
@ 24,01 SAY HELPLINE
&SAYREVERSE
WAIT
IF LASTKEY() = 9
        &SAYREVERSE
		ERASE
		SET TALK ON
		INDEX ON LAST_NAME TO TEMP
		LIST ALL FIRST_NAME,LAST_NAME
		TEXT
******************************************************************************
*       Notice  how in the record number in the left hand column is in  a    *
*       random  order?   The index will make the data  appear  in  order,    *
*       while not having to physically reorder the data.                     *
******************************************************************************


        ENDTEXT
        ? '  '
        &SAYNORMAL
        ?? CENTER('PRESS ANY KEY TO CONTINUE',76)
        &SAYREVERSE
        WAIT
        SET TALK OFF
        USE MAIL
        LOOP
ENDIF
DO LKEY
DO CASE
	CASE Y.LKEY = 'N'
	    ERASE
	    &SAYREVERSE
	    TEXT

        Thank you for joining us through this simple tutorial.  There  is 
        so much more to dBMAN that we could ever include in a disk  based 
        tutorial.   In  this  short tutorial we have tried  to  give  you 
        enough information to get you started using and enjoying dBMAN.
        ENDTEXT
        &SAYNORMAL
        @ 24,02 SAY CENTER('PRESS ANY KEY TO CONTINUE',76)
        &SAYREVERSE
        WAIT
		RETURN TO MAIN
	CASE Y.LKEY = 'P'
		EXIT
ENDCASE
ENDDO
RETURN
************
PROCEDURE NORMSCR
************
* NORMSCR.PRG
* PAINT NORMAL DBMAN SCREEN
*
@ 00,00 SAY 'CMD:'
@ 03,00 SAY 'MSG:'
@ 03,49 SAY 'FP'
@ 03,69 SAY 'Rec'
&SAYNORMAL
@ 04,00 SAY RTJUST('F7=Mem F8=Sta F9=Err F10=Cmd',80)
&SAYREVERSE
RETURN
**************
PROCEDURE LKEY
*************
* LKEY.PRG
DO CASE
     CASE LASTKEY() = 200 OR LASTKEY() = 21 OR LASTKEY() = 195
     	* PRIVOUS  UP ARROW, ^P, F9
     	Z.LKEY = 'P'
     CASE LASTKEY() = 199 OR LASTKEY() = 13 OR LASTKEY() = 187
		* MENU HOME, ^M, F1
		Z.LKEY = 'M'
		RETURN TO MAIN
	CASE LASTKEY() = 27 OR LASTKEY() = 17 OR LASTKEY() = 207
		* QUIT ESC, ^Q, END
		*CLOSE ALL
		RETURN TO MAIN
	OTHERWISE
		Z.LKEY = 'N'
ENDCASE
RETURN
*****************
PROCEDURE PRINTTXT
****************
* PRINTTXT.PRG
* PRINTS A STRING ON THE SCREEN ONE CHR AT A TIME
*
* X.STRING = STRING TO BE PRINTED
* X.STRROW = ROW
* X.STRCOL = COL
* X.STRTIME = TIME BETWEEN CHR'S
X.STRTIME = -1
STORE 1 TO Y.CURRCHR,Y.WTTIME | CURRENT CHR TO PRINT, WAIT COUNTER
Y.STRCOL = X.STRCOL
DO WHILE Y.CURRCHR <= LEN(X.STRING)
	@ X.STRROW,Y.STRCOL SAY $(X.STRING,Y.CURRCHR,1)
	INC Y.CURRCHR,Y.STRCOL
ENDDO
RETURN
********
*	DO WHILE Y.WTTIME <= X.STRTIME
*		INC Y.WTTIME
*	ENDDO
*	Y.WTTIME = 0
********
